<#

    Autore: Leone Randazzo

    Data Ultima Modifica:

    Descrizione: dimostrare le seguenti funzionalit di PoSh 2.0/3.0:

        1. Passaggio degli argomenti  in modo avanzato tramite:
            - blocco param()
            - direttiva [CmdLetBingind()]

        2. Utilizzo delle nuove funzionalit del Parser di PoSh 3.0 che permette di evitare l'uso
        della variabile speciale $_ per la scansione degli oggetti di una collezione/array all'interno
        di uno stream di input generato da una pipeline.

        In questo modo diventa irrilevante e non pi obbligatorio l'uso del CmdLet ForEach-Object (alias Foreach alias %)
        

#>

[CmdLetBinding()]
param (
    [Parameter(Mandatory=$true,
    HelpMessage="Inserisci una stringa di ricerca per la classe WMI")]
    [string] $stringa
)

Write-Debug "E' stata passata in Input la stringa `"$stringa`"."

$listaClassiWMI = Get-WmiObject -list

Write-Verbose "Ricerca in corso delle classi WMI contenenti all'interno del nome la stringa `"$stringa`"..."

# La riga seguente  da usare in caso di PoSh 2.0:
# $listaClassiWMI | % { if ($_.Name -like "*$stringa*") {$_} }

# Con PoSh 3.0  possibile semplificare la precedente riga cos:
$listaClassiWMI | ? Name -like "*$stringa*"
